{	This program is copyright (c) 1992 - 2005 Jos Kunst, the Jos Kunst heirs.	}
{	This program is free software. You can redistribute it and/or modify it 	}
{	under the terms of version 2 of the GNU General Public License, which you	}
{	should have received with it.												}
{	This program is distributed in the hope that it will be useful, but			}
{	without any warranty, expressed or implied.									}

program clastarr (input, output);

	uses
		translations;

	const
		m = 24;
		n = 8;

	type
		position = array[1..m, 1..n] of byte;
		finalarr = file of position;
		ins = (vl1, vl2, vla, vlc);

	var
		finalpos: finalarr;
		lastpos: position;
		change: boolean;
		fullScreen: rect;
		ch: char;
		str: pitchstring;
		p: byte;

	procedure settozero (var pos: position);
		var
			c, r: byte;
	begin
		for c := 1 to m do
			for r := 1 to n do
				pos[c, r] := 0
	end;

	procedure showarray;
		var
			row, col: byte;
	begin
		writeln;
		writeln('   pitch  tupl  rdur   dsg  trns   art   dyn  card');
		writeln;
		for row := 1 to m do
			begin
				if row mod 5 = 0 then
					write(row : 2)
				else
					write('  ');
				if row mod 5 <> 0 then
					write(nameof(lastpos[row, 1]) : 6)
				else
					write(lastpos[row, 1] : 6);
				for col := 2 to n do
					write(lastpos[row, col] : 6);
				writeln
			end
	end;

	procedure checkmeaning;
	begin
		showarray;
		writeln;
		change := TRUE;
		write('Do you want to make changes to this diskfile? (Y/N)-->');
		readln(ch);
		if upcased(ch) = 'N' then
			change := FALSE;
	end;

	procedure dopitches (var lapo: position);
		var
			count, p, c: byte;
			i: ins;
	begin
		for i := vl1 to vlc do
			for c := 1 to 4 do
				begin
					write('Note slot ', ord(i) * 5 + c : 2, ' has now ', nameof(lapo[ord(i) * 5 + c, 1]), '; it becomes : ');
					readln(str);
					makeintobyte(str, p);
					lapo[ord(i) * 5 + c, 1] := p
				end;
		lapo[m - 3, 1] := 0;{open}
		lapo[m, 1] := 0;{hroot}
		for count := 1 to 20 do
			if count mod 5 <> 0 then
				lapo[count, 4] := 0;{dsg-bijdragen}
		lapo[m, 4] := 0;{dsg}
	end;

	procedure dodurations (var lapo: position);
		var
			i: ins;
			p, c: byte;
	begin
		for i := vl1 to vlc do
			for c := 1 to 4 do
				begin
					write('Remaining duration at ', ord(i) * 5 + c : 2, ' is now ', lapo[ord(i) * 5 + c, 3] : 1, '; it becomes : ');
					readln(p);
					lapo[ord(i) * 5 + c, 3] := p
				end;
	end;

	procedure doothers (var lapo: position);
		var
			p, q: byte;
			matom: integer;
	begin
		p := 1;
		repeat
			write('Maximum number of tones in the chord of player ', p div 5 + 1 : 1, ' is now ', lapo[p, 8] : 1, '; it becomes:');
			readln(q);
			lapo[p, 8] := q;
			p := p + 5
		until p > 16;

		write('Measure number was ', lapo[m - 2, 2] : 1, '; it becomes:');
		readln(p);
		lapo[m - 2, 2] := p;

		write('Beat number was ', lapo[m - 1, 2] : 1, '; it becomes:');
		readln(p);
		lapo[m - 1, 2] := p;

		write('Position within beat was ', lapo[m, 2] : 1, '; it becomes:');
		readln(p);
		if p <> lapo[m, 2] then
			begin
				lapo[m, 2] := p;
				for p := 1 to 20 do
					lapo[p, 2] := 0
			end; {also triplet heritages cancelled}

		write('The cord''s space play is now ', lapo[m - 2, 1] : 1, '; it becomes:');
		readln(p);
		lapo[m - 2, 1] := p;

		write('A fixed chordtone ("melody tone") is at ', nameof(lapo[m - 1, 1]), '; it will be at:');
		readln(str);
		makeintobyte(str, p);
		lapo[m - 1, 1] := p;

		if lapo[m, 8] <> 1 then
			begin
				write('Unisono allowed. OK? (Y/N)-->');
				readln(ch);
				if upcased(ch) = 'N' then
					lapo[m, 8] := 1
			end
		else
			begin
				write('No unisono allowed. OK? (Y/N)-->');
				readln(ch);
				if upcased(ch) = 'N' then
					lapo[m, 8] := 2
			end;

		if lapo[m - 2, 8] <> 1 then
			begin
				write('No maximum continuity sought. OK? (Y/N)-->');
				readln(ch);
				if upcased(ch) = 'N' then
					lapo[m - 2, 8] := 1
			end
		else
			begin
				write('Maximum continuity sought. OK? (Y/N)-->');
				readln(ch);
				if upcased(ch) = 'N' then
					lapo[m - 2, 8] := 2
			end;

		if lapo[m - 1, 8] <> 1 then
			begin
				write('No equal distribution of tones over players. OK? (Y/N)-->');
				readln(ch);
				if upcased(ch) = 'N' then
					lapo[m - 1, 8] := 1
			end
		else
			begin
				write('Equal distribution of tones over players. OK? (Y/N)-->');
				readln(ch);
				if upcased(ch) = 'N' then
					lapo[m - 1, 8] := 2
			end;

		lapo[m - 6, 8] := 0;
{    if lapo[m-6, 8] <> 1 then begin write('Instrumentation is not keyboard only. OK? (Y/N)-->');}
{    readln(str);    if upcased(str) = 'N' then    lapo[m-6, 8] := 1    end    else}
{    begin    write('Instrumentation is just keyboard. OK? (Y/N)-->');}
{    readln ( str );    if upcased(str) = 'N' then    lapo[m-6, 8] := 2    end;}

		if lapo[m - 5, 8] = 1 then
			begin
				write('Chords are not allowed to overlap. OK? (Y/N)-->');
				readln(ch);
				if upcased(ch) = 'N' then
					lapo[m - 5, 8] := 2
			end
		else
			begin
				write('No restrictions on overlapping chords. OK? (Y/N)-->');
				readln(ch);
				if upcased(ch) = 'N' then
					lapo[m - 5, 8] := 1
			end;

		if lapo[m - 4, 8] = 1 then
			begin
				write('Rhythm is smoothed out for easier notation. OK? (Y/N)-->');
				readln(ch);
				if upcased(ch) = 'N' then
					lapo[m - 4, 8] := 2
			end
		else
			begin
				write('Rhythm may result in uneasy notation. OK? (Y/N)-->');
				readln(ch);
				if upcased(ch) = 'N' then
					lapo[m - 4, 8] := 1
			end;

		if lapo[m - 4, 8] = 1 then
			for p := 7 downto 2 do
				lapo[m - 3, p] := 2
		else
			begin {first normalize}
				for p := 7 downto 2 do
					if lapo[m - 3, p] = 1 then
						for q := p - 1 downto 2 do
							lapo[m - 3, q] := 1;
				if lapo[m - 3, 2] = 1 then
					if lapo[m - 3, 3] = 1 then
						if lapo[m - 3, 4] = 1 then
							if lapo[m - 3, 5] = 1 then
								if lapo[m - 3, 6] = 1 then
									if lapo[m - 3, 7] = 1 then
										begin
											write('Eighth notes and smaller are disallowed. OK? (Y/N)-->');
											readln(ch);
											if upcased(ch) = 'N' then
												lapo[m - 3, 7] := 2
										end
									else
										begin
											write('Triplet eighths & smaller are disallowed. OK? (Y/N)-->');
											readln(ch);
											if upcased(ch) = 'N' then
												lapo[m - 3, 6] := 2
										end
								else
									begin
										write('Sixteenths & smaller are disallowed. OK? (Y/N)-->');
										readln(ch);
										if upcased(ch) = 'N' then
											lapo[m - 3, 5] := 2
									end
							else
								begin
									write('Triplet sixteenths & smaller are disallowed. OK? (Y/N)-->');
									readln(ch);
									if upcased(ch) = 'N' then
										lapo[m - 3, 4] := 2
								end
						else
							begin
								write('32nds & smaller are disallowed. OK? (Y/N)-->');
								readln(ch);
								if upcased(ch) = 'N' then
									lapo[m - 3, 3] := 2
							end
					else
						begin
							write('Triplet 32nds are disallowed. OK? (Y/N)-->');
							readln(ch);
							if upcased(ch) = 'N' then
								lapo[m - 3, 2] := 2
						end
				else
					for p := 7 downto 2 do
						if lapo[m - 3, p] mod 2 = 0 then
							begin
								case p of
									7: 
										write('Eighths are allowed. OK? (Y/N)-->');
									6: 
										write('Triplet eighths are allowed. OK? (Y/N)-->');
									5: 
										write('Sixteenths are allowed. OK? (Y/N)-->');
									4: 
										write('Triplet sixteenths are allowed. OK? (Y/N)-->');
									3: 
										write('Thirtyseconds are allowed. OK? (Y/N)-->');
									2: 
										write('Triplet thirtyseconds are allowed. OK? (Y/N)-->');
								end;
								readln(ch);
								if upcased(ch) = 'N' then
									for q := p downto 2 do
										lapo[m - 3, q] := 1
							end
			end;

		if lapo[m - 3, 8] = 1 then
			begin
				write('Chord progressions in thirds are being preferred. OK? (Y/N)-->');
				readln(ch);
				if upcased(ch) = 'N' then
					lapo[m - 3, 8] := 2
			end
		else
			begin
				write('No preference for thirds in chord progressions. OK? (Y/N)-->');
				readln(ch);
				if upcased(ch) = 'N' then
					lapo[m - 3, 8] := 1
			end;

{zzzzzz zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz}
		write('Basedur value is now ', lapo[m - 1, 4] : 1, '; it becomes:');
		readln(p);
		lapo[m - 1, 4] := p;

		write('Anchor dsg is now ', lapo[m - 2, 4] : 1, '; it becomes:');
		readln(p);
		lapo[m - 2, 4] := p;

{-------------transition characteristics----------------------------------------------}
		write('Target value of transfromprec is ', lapo[m - 1, 5] div 10 : 1, '; it becomes:');
		readln(p);
		lapo[m - 1, 5] := lapo[m - 1, 5] mod 10 + p * 10;
		write('Marksmanship for transfromprec is ', lapo[m - 2, 5] div 10 : 1, '; it becomes:');
		readln(p);
		lapo[m - 2, 5] := lapo[m - 2, 5] mod 10 + p * 10;
		write('Target value of transcontour is ', lapo[m - 1, 5] mod 10 : 1, '; it becomes:');
		readln(p);
		lapo[m - 1, 5] := (lapo[m - 1, 5] div 10) * 10 + p;
		write('Marksmanship for transcontour is ', lapo[m - 2, 5] mod 10 : 1, '; it becomes:');
		readln(p);
		lapo[m - 2, 5] := (lapo[m - 2, 5] div 10) * 10 + p;
{--------------articulation characteristics--------------------------------------------}
		write('Target value of articulation is ', lapo[m - 1, 6] div 10 : 1, '; it becomes:');
		readln(p);
		lapo[m - 1, 6] := lapo[m - 1, 6] mod 10 + p * 10;
		write('Marksmanship for articulation is ', lapo[m - 2, 6] div 10 : 1, '; it becomes:');
		readln(p);
		lapo[m - 2, 6] := lapo[m - 2, 6] mod 10 + p * 10;
		write('Target value of timbre is ', lapo[m - 1, 6] mod 10 : 1, '; it becomes:');
		readln(p);
		lapo[m - 1, 6] := (lapo[m - 1, 6] div 10) * 10 + p;
		write('Marksmanship for timbre is ', lapo[m - 2, 6] mod 10 : 1, '; it becomes:');
		readln(p);
		lapo[m - 2, 6] := (lapo[m - 2, 6] div 10) * 10 + p;
{---------------dynamic characteristics---------------------------------------------}
		write('Target value of dynlevel is ', lapo[m - 1, 7] div 10 : 1, '; it becomes:');
		readln(p);
		lapo[m - 1, 7] := lapo[m - 1, 7] mod 10 + p * 10;
		write('Marksmanship for dynlevel is ', lapo[m - 2, 7] div 10 : 1, '; it becomes:');
		readln(p);
		lapo[m - 2, 7] := lapo[m - 2, 7] mod 10 + p * 10;
		write('Target value of dyncontour is ', lapo[m - 1, 7] mod 10 : 1, '; it becomes:');
		readln(p);
		lapo[m - 1, 7] := (lapo[m - 1, 7] div 10) * 10 + p;
		write('Marksmanship for dyncontour is ', lapo[m - 2, 7] mod 10 : 1, '; it becomes:');
		readln(p);
		lapo[m - 2, 7] := (lapo[m - 2, 7] div 10) * 10 + p;

		matom := 100 * lapo[m - 2, 3] + 10 * lapo[m - 1, 3] + lapo[m, 3];
		write('Current melody (or music) atom is ', matom : 3, '; it becomes:');
		readln(matom);
		lapo[m - 2, 3] := matom div 100;
		lapo[m - 1, 3] := (matom mod 100) div 10;
		lapo[m, 3] := matom mod 10;

	end;

	procedure readinposition;
	begin
		reset(finalpos);
		while not eof(finalpos) do
			read(finalpos, lastpos)
	end;

	procedure docolumn;
		var
			ch: char;
	begin
		writeln('Do you want to change 1: pitches');
		writeln('                      2: remaining durations');
		writeln('                      3: other values');
		write('                      (1/2/3)-->');
		readln(ch);
		case ch of
			'1': 
				dopitches(lastpos);
			'2': 
				dodurations(lastpos);
			'3': 
				doothers(lastpos);
		end;
	end;

begin
	SetRect(fullScreen, 9, 44, 502, 856);
	SetTextRect(fullScreen);
	ShowText;
	settozero(lastpos);
	write('Do you want to see the current starting point or the new end point? S/E-->');
	readln(ch);
	if (chr(ord(ch) - 32) = 'S') or (ch = 'S') then
		open(finalpos, 'oldfinalposfile')
	else
		open(finalpos, 'newfinalposfile1');
	readinposition;
	repeat
		checkmeaning;
		if change then
			docolumn;
{ bij ad hoc reparaties: puntkomma weg, else, statements, ;  zoals in:  }
{else}
{for p := 1 to 13 do}
{lastpos [ p , 2 ] := 1;}
	until change = FALSE;
	rewrite(finalpos);
	write(finalpos, lastpos);
	close(finalpos)
end.