{	This program is copyright (c) 1993 - 2005 Jos Kunst, the Jos Kunst heirs.	}
{	This program is free software. You can redistribute it and/or modify it 	}
{	under the terms of version 2 of the GNU General Public License, which you	}
{	should have received with it.												}
{	This program is distributed in the hope that it will be useful, but			}
{	without any warranty, expressed or implied.									}

program answerinterval;
	uses
		translations;

{de formule is de volgende:}
{start1-start2 = (step1-step2)*stepsfromcenter}
{waarin}
{ start1, start2, step1 en step2 in modale rekenstappen (bv 8 per octaaf, positief of negatief) zijn uitgedrukt;}
{ voor step1 en step2 pos = stijgend en neg = dalend;}
{ en voor stepsfromcenter pos = na, en neg = vr het punt waarin alle stemmen samenvallen;}
{waaruit volgt:}
{step1-step2 = (start1-start2)/stepsfromcenter}
{step2 = step1- (start1-start2)/stepsfromcenter}


	var
		p, start1, start2, targ1, modebase, modetransp: byte;
		targ2, step1, step2, moddistance, center: integer;
		shortstr: pitchstring;
		ch: char;
		longScreen: rect;
		modeset, setofpossibilities: pitchset;
		narrowing, done: boolean;

	procedure calculatedivisibility (number: byte;
									var setofdivisors: pitchset);
{-------- finds the set of positive integer divisors of any positive integer < 256 -------------}
		var
			p: byte;
	begin
		setofdivisors := [number];
		for p := 1 to number div 2 do
			if number mod p = 0 then
				setofdivisors := setofdivisors + [p]
	end;

	procedure calculatemodalinterval (p1: byte;
									p2: integer;
									mode: pitchset;
									var numberofsteps: integer);
{------ returns the number of modal steps bridging the distance between two given tones ----------}
		var
			p, q: integer;
	begin
		p := p1;
		q := 0;
		numberofsteps := 0;
		if p1 < p2 then
			q := 1
		else if p2 < p1 then
			q := -1;
		if q <> 0 then {q blijft 0 als p1 = p2!}
			repeat
				p := p + q;
				if (p in mode) or (p + 60 in mode) then
					numberofsteps := numberofsteps + q
			until ((p = (-50)) or (p > 180)) or (p = p2)
	end;

	procedure calculatechromaticpitch (p1: byte;
									modalstep: integer;
									mode: pitchset;
									var p2: integer);
{-------- returns the chromatic pitch reached from a given tone by a given modal step ----------}
		var
			q, mstep: integer;
	begin
		p2 := p1;
		q := 0;
		if modalstep > 0 then
			q := 1
		else if modalstep < 0 then
			q := -1;
		mstep := modalstep;
		if q <> 0 then {q blijft 0 als modalstep = 0!}
			repeat
				p2 := p2 + q;
				if (p2 in mode) or (p2 + 60 in mode) then
					mstep := mstep - q;
			until ((p2 < (-50)) or (p2 > 180)) or (mstep = 0)
	end;

	procedure writesomeothers (tp1: byte;
									tp2, st1, st2: integer;
									m: pitchset);
{------- writes to screen some possible pitches other than the target tones -----------}
		var
			modaldist, othertone: integer;
			numberofparts, lopoint, hipoint, counter, modalsteplength: byte;
	begin
		calculatemodalinterval(tp1, tp2, m, modaldist);
		if abs(st1 - st2) > 0 then
			numberofparts := abs(st1 - st2) - 1
		else
			numberofparts := 0;
		modalsteplength := abs(modaldist) div (numberofparts + 1);
		if tp1 >= tp2 then
			begin
				hipoint := tp1;
				lopoint := tp2
			end
		else
			begin
				hipoint := tp2;
				lopoint := tp1
			end;
		if narrowing then
			write('...closing down the chord to a (virtual) interval of ', modalsteplength : 1, ':')
		else
			write('...opening up the chord to a (virtual) interval of ', modalsteplength : 1, ':');
		for counter := 1 to 2 do
			begin
				calculatechromaticpitch(lopoint, modalsteplength * counter, m, othertone);
				write(' ', nameof(othertone))
			end;
		write(' ...');
		for counter := 2 downto 1 do
			begin
				calculatechromaticpitch(hipoint, -(modalsteplength * counter), m, othertone);
				write(' ', nameof(othertone))
			end;
		writeln('.')
	end;

begin
	SetRect(longScreen, 9, 44, 502, 836);
	SetTextRect(longScreen);
	showtext;
	done := FALSE;
	repeat
		modeset := [];
		write('Type in your mode:-->');
		readln(shortstr);
		taketobyteclass(shortstr, modebase);
		modetransp := modebase - 12; {--------- distance of chosen mode from c ------------------}
		p := modetransp;
		modeset := [12 + p, 14 + p, 15 + p, 16 + p, 19 + p, 20 + p, 21 + p, 23 + p];
		for p := 12 to 168 do {168=180-12}
			if p in modeset then
				modeset := modeset + [p + 12];
		for p := 23 downto 12 do
			if p in modeset then
				modeset := modeset + [p - 12];
		write('Type in the starting pitch of your first part:-->');
		repeat
			readln(shortstr);
			makeintobyte(shortstr, start1);
			if not (start1 in modeset) then
				write('Not in mode! Try again... -->')
		until start1 in modeset;
		write('Type in the target pitch of your first part:-->');
		repeat
			readln(shortstr);
			makeintobyte(shortstr, targ1);
			if not (targ1 in modeset) then
				write('Not in mode! Try again... -->')
		until targ1 in modeset;
		write('Type in the starting pitch of your second (answering) part:-->');
		repeat
			readln(shortstr);
			makeintobyte(shortstr, start2);
			if not (start2 in modeset) then
				write('Not in mode! Try again... -->')
		until start2 in modeset;
		calculatemodalinterval(start1, start2, modeset, moddistance);
		calculatedivisibility(abs(moddistance), setofpossibilities);
		calculatemodalinterval(start1, targ1, modeset, step1);
		for p := 1 to abs(moddistance) do
			if p in setofpossibilities then
				begin
					step2 := step1 - moddistance div p;  { always gives a > (closing down) chord progression... }
					narrowing := TRUE;
					calculatechromaticpitch(start2, step2, modeset, targ2);
					calculatechromaticpitch(start2, p * step2, modeset, center);
					writeln('From a point ', p : 1, ' phases from center ', nameof(center), ' you go to ', nameof(targ2), '...');
					writesomeothers(targ1, targ2, step1, step2, modeset);
					step2 := step1 - moddistance div (-p);  { always gives a < (opening up) chord progression... }
					narrowing := FALSE;
					calculatechromaticpitch(start2, step2, modeset, targ2);
					calculatechromaticpitch(start2, (-p) * step2, modeset, center);
					writeln('From a point ', p : 1, ' phases from center ', nameof(center), ' you go to ', nameof(targ2), '...');
					writesomeothers(targ1, targ2, step1, step2, modeset)
				end;
		if start1 = start2 then
			begin
				center := start1;
				writeln('From center ', nameof(center), ' you go to any point within the mode.');
			end;
		write('Done? (Y/N)-->');
		readln(ch);
		if upcased(ch) <> 'N' then
			done := TRUE
	until done
end.