{	This program is copyright (c) 1993 - 2005 Jos Kunst, the Jos Kunst heirs.	}
{	This program is free software. You can redistribute it and/or modify it 	}
{	under the terms of version 2 of the GNU General Public License, which you	}
{	should have received with it.												}
{	This program is distributed in the hope that it will be useful, but			}
{	without any warranty, expressed or implied.									}

unit hands;
interface
	uses
		translations;
	var
		LHout, Rhout: boolean;
		LHwidth, RHwidth: byte;
	function RHacceptable (RHs: pitchset): boolean;
	function LHacceptable (LHs: pitchset): boolean;
	procedure adapttoRH (var h: pitchset);
	procedure adapttoLH (var h: pitchset);
	procedure gripinhands (var handsset: pitchset; var LHset, RHset: pitchset);
	procedure counttones (cs: pitchset; var numberoftones: byte);
	function centerofmassof (ch: pitchset; fromnote, tonote: byte): byte;
	function handsloxof (cs: pitchset): pitchset;

implementation
	procedure counttones (cs: pitchset; var numberoftones: byte);
		var
			p: byte;
	begin
		numberoftones := 0;
		for p := bottomnote to topnote do
			if p in cs then
				numberoftones := numberoftones + 1
	end;

	function centerofmassof (ch: pitchset; fromnote, tonote: byte): byte;
		var
			p, lastp, secondpastp, centerofmass, cofm: byte;
			totalweight, twght: integer;
	begin
		totalweight := 0;
		centerofmass := 0;
		lastp := 0;
		for p := fromnote to tonote do
			if p in ch then
				begin
{write(p : 2, ' ');}
					if centerofmass = 0 then { i.e.: this is the first (lowest) chordnote }
						centerofmass := p
					else if totalweight = 0 then { i.e.: this is the second (lowest but one) chordnote }
						begin
							totalweight := p - lastp;
							centerofmass := centerofmass + round((p - lastp) / 2);
						end
					else { i.e.: from the third chordnote onwards }
						begin
							cofm := centerofmass;
							twght := totalweight;
							totalweight := totalweight + (p - lastp);
							centerofmass := centerofmass + round((((p - lastp) / 2) / totalweight) * (lastp - centerofmass));
							centerofmass := centerofmass + round((((p - lastp) / 2) / totalweight) * (p - centerofmass));
							if centerofmass = cofm then { solving a problem occurring with larger clusters... }
								totalweight := twght;
						end;
					lastp := p
				end;
		centerofmassof := centerofmass;
	end;

	function handsloxof (cs: pitchset): pitchset;
		var
			center: byte;
	begin
		center := centerofmassof(cs, bottomnote, topnote);
		if LHout or RHout then
			handsloxof := [center]
		else
			handsloxof := [centerofmassof(cs, bottomnote, center), centerofmassof(cs, center + 1, topnote)]
	end;

	function RHacceptable (RHs: pitchset): boolean;
		var
			p, a, b, c, d, e: byte;
	begin
		RHacceptable := TRUE;
		counttones(RHs, p);
		if p > 5 then
			begin
				RHacceptable := FALSE;
				writeln(' - too many in RH! - ')
			end
		else
			begin
				a := 0;
				b := 0;
				c := 0;
				d := 0;
				e := 0;
				for p := bottomnote to topnote do
					if p in RHs then
						begin
							if e = d then
								e := p;
							if d = c then
								d := p;
							if c = b then
								c := p;
							if b = a then
								b := p;
							if a = 0 then
								a := p
						end;
				if e - d > 3 then
					RHacceptable := FALSE;
				if e - c > 6 then
					RHacceptable := FALSE;
				if e - b > 9 then
					RHacceptable := FALSE;
				if e - a > 12 then
					RHacceptable := FALSE
			end
	end;

	function LHacceptable (LHs: pitchset): boolean;
		var
			p, a, b, c, d, e: byte;
	begin
		LHacceptable := TRUE;
		counttones(LHs, p);
		if p > 5 then
			begin
				LHacceptable := FALSE;
				writeln(' - too many in LH! - ')
			end
		else
			begin
				a := 0;
				b := 0;
				c := 0;
				d := 0;
				e := 0;
				for p := topnote downto bottomnote do
					if p in LHs then
						begin
							if e = d then
								e := p;
							if d = c then
								d := p;
							if c = b then
								c := p;
							if b = a then
								b := p;
							if a = 0 then
								a := p
						end;
				if d - e > 3 then
					LHacceptable := FALSE;
				if c - e > 6 then
					LHacceptable := FALSE;
				if b - e > 9 then
					LHacceptable := FALSE;
				if a - e > 12 then
					LHacceptable := FALSE
			end
	end;

	procedure adapttoRH (var h: pitchset);
		var
			origh, changedh, goodh: pitchset;
			dens, p, q, r, octaveds, ch, change: byte;
			oct: boolean;
	begin
		origh := h;
		counttones(origh, dens);
		if dens > 5 then
			h := []
		else
			begin
				goodh := [];
				changedh := origh;
				octaveds := 0;
				change := 24;
				ch := 0;
				p := bottomnote - 1;
				oct := FALSE;
				if dens > 1 then
					repeat
						p := p + 1;
						if p in changedh then
							begin
								changedh := changedh - [p];
								q := p + 12;
								if q in changedh then
									oct := TRUE;
								changedh := changedh + [q];
								octaveds := octaveds + 1;
								r := p;
								repeat
									r := r + 1
								until r in changedh;
								ch := ch + (r - p);
								if not oct then
									begin
										r := q;
										repeat
											r := r - 1
										until r in changedh;
										ch := ch + (q - r);
									end
								else
									oct := FALSE;
								if RHacceptable(changedh) then
									if ch < change then
										begin
											goodh := changedh;
											change := ch
										end
							end;
					until octaveds >= dens - (dens div 2);
				changedh := origh;
				octaveds := 0;
				ch := 0;
				p := topnote + 1;
				oct := FALSE;
				if dens > 1 then
					repeat
						p := p - 1;
						if p in changedh then
							begin
								changedh := changedh - [p];
								q := p - 12;
								if q in changedh then
									oct := TRUE;
								changedh := changedh + [q];
								octaveds := octaveds + 1;
								r := p;
								repeat
									r := r - 1
								until r in changedh;
								ch := ch + (p - r);
								if not oct then
									begin
										r := q;
										repeat
											r := r + 1
										until r in changedh;
										ch := ch + (r - q)
									end
								else
									oct := FALSE;
								if RHacceptable(changedh) then
									if ch < change then
										begin
											goodh := changedh;
											change := ch
										end
							end;
					until octaveds >= dens - (dens div 2);
				h := goodh
			end
	end;

	procedure adapttoLH (var h: pitchset);
		var
			origh, changedh, goodh: pitchset;
			dens, p, q, r, octaveds, ch, change: byte;
			oct: boolean;
	begin
		origh := h;
		counttones(origh, dens);
		if dens > 5 then
			h := []
		else
			begin
				goodh := [];
				changedh := origh;
				octaveds := 0;
				change := 24;
				ch := 0;
				p := bottomnote - 1;
				oct := FALSE;
				if dens > 1 then
					repeat
						p := p + 1;
						if p in changedh then
							begin
								changedh := changedh - [p];
								q := p + 12;
								if q in changedh then
									oct := TRUE;
								changedh := changedh + [q];
								octaveds := octaveds + 1;
								r := p;
								repeat
									r := r + 1
								until r in changedh;
								ch := ch + (r - p);
								if not oct then
									begin
										r := q;
										repeat
											r := r - 1
										until r in changedh;
										ch := ch + (q - r);
									end
								else
									oct := FALSE;
								if LHacceptable(changedh) then
									if ch < change then
										begin
											goodh := changedh;
											change := ch
										end
							end;
					until octaveds >= dens - (dens div 2);
				changedh := origh;
				octaveds := 0;
				ch := 0;
				p := topnote + 1;
				oct := FALSE;
				if dens > 1 then
					repeat
						p := p - 1;
						if p in changedh then
							begin
								changedh := changedh - [p];
								q := p - 12;
								if q in changedh then
									oct := TRUE;
								changedh := changedh + [q];
								octaveds := octaveds + 1;
								r := p;
								repeat
									r := r - 1
								until r in changedh;
								ch := ch + (p - r);
								if not oct then
									begin
										r := q;
										repeat
											r := r + 1
										until r in changedh;
										ch := ch + (r - q)
									end
								else
									oct := FALSE;
								if LHacceptable(changedh) then
									if ch < change then
										begin
											goodh := changedh;
											change := ch
										end
							end;
					until octaveds >= dens - (dens div 2);
				h := goodh
			end
	end;

	procedure gripinhands (var handsset: pitchset; var LHset, RHset: pitchset);
		var
			LHcenter, RHcenter, p, q: byte;
			handslox: pitchset;
{}
	begin
		handslox := handsloxof(handsset);
		LHset := [];
		RHset := [];
{------- in the case of LHout or RHout we get only one pitch in handslox! --------}
		if RHout then
			begin
				LHcenter := bottomnote - 1;
				repeat
					LHcenter := LHcenter + 1
				until LHcenter in handslox;
				for p := bottomnote to topnote do
					if p in handsset then
						if p < LHcenter then
							begin
								q := p;
								while q < LHcenter - (LHwidth div 2) do
									q := q + 12;
								LHset := LHset + [q]
							end
						else
							begin
								q := p;
								while q > LHcenter + (LHwidth div 2) do
									q := q - 12;
								LHset := LHset + [q]
							end;
			end
		else if LHout then
			begin
				RHcenter := bottomnote - 1;
				repeat
					RHcenter := RHcenter + 1
				until RHcenter in handslox;
				for p := bottomnote to topnote do
					if p in handsset then
						if p < RHcenter then
							begin
								q := p;
								while q < RHcenter - (RHwidth div 2) do
									q := q + 12;
								RHset := RHset + [q]
							end
						else
							begin
								q := p;
								while q > RHcenter + (RHwidth div 2) do
									q := q - 12;
								RHset := RHset + [q]
							end
			end
		else
			begin
				LHcenter := bottomnote - 1;
				repeat
					LHcenter := LHcenter + 1
				until LHcenter in handslox;
				RHcenter := LHcenter;
				repeat
					RHcenter := RHcenter + 1
				until RHcenter in handslox;
				LHset := [];
				RHset := [];
				for p := bottomnote to topnote do
					if p in handsset then
						if p < LHcenter then
							begin
								q := p;
								while q < LHcenter - (LHwidth div 2) do
									q := q + 12;
								LHset := LHset + [q]
							end
						else if abs(p - LHcenter) < abs(RHcenter - p) then
							begin
								q := p;
								while q > LHcenter + (LHwidth div 2) do
									q := q - 12;
								LHset := LHset + [q]
							end
						else if p < RHcenter then
							begin
								q := p;
								while q < RHcenter - (RHwidth div 2) do
									q := q + 12;
								RHset := RHset + [q]
							end
						else
							begin
								q := p;
								while q > RHcenter + (RHwidth div 2) do
									q := q - 12;
								RHset := RHset + [q]
							end
			end;
		if not RHacceptable(RHset) then
			adapttoRH(RHset);
		if not LHacceptable(LHset) then
			adapttoLH(LHset);
		handsset := LHset + RHset
	end;
end.